#include "g_local.h"
#include "BotMain.h"

/***************************************************************************************
original code: TeamWhore

filename: BotMain.c

Description: This file contains the Bot think function 'Botthink'

###################### Function Descriptions ##################################

void Botthink(gentity_t *bot)
  Perform bot actions based on state

###############################################################################

-----changes:---------------------
  March 4, 2004 
	rince - added comments to help explain the code
  March 4-5, 2004
    TeamWhore - combined my new comments with rince's
	     moved all state-handling code to BotState.c
		 added call to BotCheckAmmoState
  March 6-7, 2004
	TeamWhore - Massively cleaned up the Botthink function.
			it now passes off control to a series of other functions, rather
			than handling everything itself.  Much cleaner.
		 added function calls to BotStateActions, BotEvents and BotSendCommand


---- other things ------
*********************************************************************************
commands related to bot and nodes - line 662 - g_svcmds.c
---- quick reference of added commands -----
addbot - adds a bot
nd_addnode - adds a node
nd_connect - connects two nodes together
nd_clear - Clears all nodes
nd_save - saves the node using the given filename
nd_load - loads node using the given filename
entnum - prints info about object(s) we are looking at - useful for certain nodes
****************************************************************************************/

/*///////////////////////////////////////
Botthink
pretty much the main bot control function...called every serverframe
this functions passes control to other functions which handle virtually
every aspect of the bot's behaviour
/*///////////////////////////////////////
void Botthink(gentity_t *bot)
{	usercmd_t ucmd;										//we 'fake' a command from a person - buttons pressed, etc
	int state = botinfo[bot->s.number].state;			//stores the bot's state info
	botinfo[bot->s.number].ucmd = &ucmd;

	memset(&ucmd, 0, sizeof(ucmd));						//set up some initial values for each frame
	VectorCopy(bot->client->ps.viewangles, bot->s.angles);
	VectorSet(bot->client->ps.delta_angles, 0, 0, 0);

	BotParseServerCommand(bot, &state);		//prevents 'server command overflow'
	BotStateActions(bot, &state);			//handle all of the bot's state-based actions
	BotEvents(bot);							//respond to any events

	//don't run around looking through the scope
	if (!bot->enemy && bot->s.weapon == WP_SNIPERRIFLE)
		bot->client->ps.weapon = WP_MAUSER;					//just for looks, so not running around zoomed

	BotSendCommand(bot, &state);			//send the bot's command to the server
}



/*the code below this was part of my old node handling code
it can't be used as it is now, but I left it included because
we will need to handle these situations eventually, and this is
easier for me than having to try to remember all this again
you can ignore it, I'm not going to comment it :P
*/




/*qboolean BotDoBreakable(gentity_t *bot, usercmd_t *ucmd)
{
	vec3_t pos;
	float dist;
	int grenType;
	gentity_t *ent = &(g_entities[nodes[bot->modinfo.nextNode].objectNum]);

	if (ent->health <= 0)									//already been exploded
		return qtrue;

	if (bot->client->sess.sessionTeam == TEAM_RED)
		grenType = WP_GRENADE_LAUNCHER;
	else
		grenType = WP_GRENADE_PINEAPPLE;

	if (bot->client->ps.ammoclip[BG_FindClipForWeapon(grenType)] == 0)
		return qtrue;										//FIXME: change to wandering

	VectorAdd(ent->r.mins, ent->r.maxs, pos);
	VectorScale(pos, 0.5, pos);
	pos[2] = ent->r.mins[2];
	VectorSubtract(pos, bot->r.currentOrigin, pos);
	vectoangles(pos, bot->s.angles);
	
	dist = VectorLength(pos);

	if (dist < 375)
	{
		BotMove(bot, DIR_BACKWARD, ucmd, 0);
		bot->modinfo.movingAtNode = qtrue;
		bot->modinfo.framesAtNode--;						//don't throw nade before in position
		return qfalse;
	}
	else if (dist > 425)
	{
		BotMove(bot, DIR_FORWARD, ucmd, 0);
		bot->modinfo.movingAtNode = qtrue;
		bot->modinfo.framesAtNode--;
		return qfalse;
	}

	if (bot->modinfo.framesAtNode == 1)
		ChooseWeapon(bot, grenType);
	else if (bot->modinfo.framesAtNode == 5)
		ucmd->buttons |= BUTTON_ATTACK;
	else if (bot->modinfo.framesAtNode == 9)
		ChooseWeapon(bot, 0);

	return qfalse;
}*/
